// Test Bentch for write

`include "AS7C164.v"

`timescale 1 ns/1 ps

module TEST_AS7C164;


`define tsim  20000


reg  OE_BAR,CE1_BAR,CE2,WE_BAR;
wire [12:0] A;
wire [7:0] DIO;
reg [7:0] data_read;
reg [7:0] temp_data;
reg [12:0] ADDRESS;

AS7C164 tb(A,DIO,OE_BAR,CE1_BAR,CE2,WE_BAR);

initial
   begin
    $dumpvars(0,TEST_AS7C164);
   $timeformat(-9,1,"ns",10);
   $dumpfile("./TEST_AS7C164.vcd"); 

    #100;						/* deselect */
        OE_BAR <= 1'b1; 
        ADDRESS <= 13'h0000;
        CE1_BAR <= 1'b1; CE2 <= 1'b0;
        WE_BAR <= 1'b1;
      temp_data <= 8'h00;
							
  
  /*access WWRR  Ce/we Controlled write  */   /* twc write cycle = 12ns */
  
  
    #100; 
        OE_BAR <= 1'b1; 
        ADDRESS <= 13'h0001;
    #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
    #1; WE_BAR <= 1'b0;
    #1; temp_data <= 8'h01;
    #8; CE1_BAR <= 1'b1; CE2 <= 1'b0;
    							/* twc write cycle = 12ns */
    #1;
       OE_BAR <= 1'b1;  
       ADDRESS <= 13'h0002;
   #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
   #1; WE_BAR <= 1'b0;
   #1; temp_data <= 8'h02;
   #8; WE_BAR <= 1'b1;
 							/* trc read cycle = 12ns */         
   #1;
       ADDRESS <= 13'h0001;
       WE_BAR <= 1'b1;
   #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
   #1; OE_BAR <= 1'b0; 
  
  #12;							/* trc read cycle = 12ns */
       ADDRESS <= 13'h0002;
       WE_BAR <= 1'b1;
  #1;  CE1_BAR <= 1'b0; CE2 <= 1'b1;
  #1;  OE_BAR <= 1'b0;
       

# 12;							/* deselect */
     ADDRESS <= 13'h0000;
     CE1_BAR <= 1'b1; CE2 <= 1'b0;
     WE_BAR <= 1'b1;
     
  /*Address Initiating WWRR  */                  /* twc write cycle = 12ns */
  
  
    #100; 
        OE_BAR <= 1'b1; 
        ADDRESS <= 13'h0003;
    #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
    #1; WE_BAR <= 1'b0;
    #1; temp_data <= 8'h03;
    #8; //CE1_BAR <= 1'b1; CE2 <= 1'b0;
    							/* twc write cycle = 12ns */
    #1;
       OE_BAR <= 1'b1;  
       ADDRESS <= 13'h0004;
   #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
   #1; WE_BAR <= 1'b0;
   #1; temp_data <= 8'h04;
   #8; //WE_BAR <= 1'b1;
 							/* trc read cycle = 12ns */         
   #1;
       ADDRESS <= 13'h0003;
       WE_BAR <= 1'b1;
   #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
   #1; OE_BAR <= 1'b0; 
  
  #10;							/* trc read cycle = 12ns */
       ADDRESS <= 13'h0004;
       WE_BAR <= 1'b1;
  #1;  CE1_BAR <= 1'b0; CE2 <= 1'b1;
  #1;  OE_BAR <= 1'b0;
       

 #10;							/* deselect */
     ADDRESS <= 13'h0000;
     CE1_BAR <= 1'b1; CE2 <= 1'b0;
     WE_BAR <= 1'b1;

/*Address Initiating WRWR   OE Control read */
							/* twc write cycle = 12ns */
    #100; 
        OE_BAR <= 1'b1; 
        ADDRESS <= 13'h0005;
    #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
    #1; WE_BAR <= 1'b0;
    #1; temp_data <= 8'h05;
    #8; CE1_BAR <= 1'b1; CE2 <= 1'b0;
    							/* trc read cycle = 12ns */
   #1;
       ADDRESS <= 13'h0005;
       WE_BAR <= 1'b1;
   #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
   #7; OE_BAR <= 1'b0;    
   
   
   #12;                                                /* twc write cycle = 12ns */
       OE_BAR <= 1'b1;  
       ADDRESS <= 13'h0006;
   #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
   #1; WE_BAR <= 1'b0;
   #1; temp_data <= 8'h06;
   #8; CE1_BAR <= 1'b1; CE2 <= 1'b0;
 							/* trc read cycle = 12ns */         
            
  #1;
       ADDRESS <= 13'h0006;
       WE_BAR <= 1'b1;
  #1;  CE1_BAR <= 1'b0; CE2 <= 1'b1;
  #7;  OE_BAR <= 1'b0; 
       

# 12;                            			/* deselect */
     ADDRESS <= 13'h0000;
     CE1_BAR <= 1'b1; CE2 <= 1'b0;
     WE_BAR <= 1'b1;
     
 
 /*Data Initiating WRWR    */
 
 #100;						/* twc write cycle = 12ns */
        OE_BAR <= 1'b1; 
        ADDRESS <= 13'h0000;
        CE1_BAR <= 1'b1; CE2 <= 1'b0;
        WE_BAR <= 1'b1;
      temp_data <= 8'h00;
							/* twc write cycle = 12ns */
    #100; 
        OE_BAR <= 1'b1; 
        ADDRESS <= 13'h0007;
    #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
    #1; WE_BAR <= 1'b0;
    #1; temp_data <= 8'h01;
    #1; temp_data <= 8'h07;
    #7; CE1_BAR <= 1'b1; CE2 <= 1'b0;
    							/* trc read cycle = 12ns */
   #1;
       ADDRESS <= 13'h0007;
       WE_BAR <= 1'b1;
   #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
   #1; OE_BAR <= 1'b0; 
   
   
   #12;
       OE_BAR <= 1'b1;  
       ADDRESS <= 13'h0008;
   #1; CE1_BAR <= 1'b0; CE2 <= 1'b1;
   #1; WE_BAR <= 1'b0;
   #1; temp_data <= 8'h03;
   #1; temp_data <= 8'h08;
   #7; CE1_BAR <= 1'b1; CE2 <= 1'b0;
 							/* trc read cycle = 12ns */         
            
  #1;
       ADDRESS <= 13'h0008;
       WE_BAR <= 1'b1;
  #1;  CE1_BAR <= 1'b0; CE2 <= 1'b1;
  #1;  OE_BAR <= 1'b0;
       

# 12;
     ADDRESS <= 13'h0000;
     CE1_BAR <= 1'b1; CE2 <= 1'b0;
     WE_BAR <= 1'b1;





  #200;
  data_read =  {tb.mem_array0[00001]};
  $display($time, "\t%h\n", data_read); 
  data_read =  {tb.mem_array0[00002]};
  $display($time, "\t%h\n", data_read);
  data_read =  {tb.mem_array0[00003]};
  $display($time, "\t%h\n", data_read); 
  data_read =  {tb.mem_array0[00004]};
  $display($time, "\t%h\n", data_read);
  data_read =  {tb.mem_array0[00005]};
  $display($time, "\t%h\n", data_read); 
  data_read =  {tb.mem_array0[00006]};
  $display($time, "\t%h\n", data_read);
  data_read =  {tb.mem_array0[00007]};
  $display($time, "\t%h\n", data_read);
  data_read =  {tb.mem_array0[00008]};
  $display($time, "\t%h\n", data_read);
     
   
end

 assign DIO = (OE_BAR) ? temp_data : 8'hz ; 
 assign A = ADDRESS; 

//******* simultion Finish by `tsim ***********
initial # `tsim $finish;

endmodule
